/** 
 *  Sample program for Hyper Operating System V4 Advance
 *
 * @file  sample.c
 * @brief %jp{ץץ}%en{Sample program}
 *
 * @version $Id: sample.c,v 1.1.1.1 2006/08/16 16:27:04 ryuz Exp $
 *
 * Copyright (C) 1998-2006 by Project HOS
 * http://sourceforge.jp/projects/hos/
 */


#include "kernel.h"
#include "kernel_id.h"
#include "sci1.h"
#include "regs_sh7144.h"

ID mbxid;
ID mpfid;

/** %jp{å¤} */
typedef struct t_print_msg
{
	T_MSG msg;
	char  text[32];
} T_PRINT_MSG;


/** %jp{ϥɥ} */
void Sample_Initialize(VP_INT exinf)
{
	T_CMPF cmpf;
	T_CMBX cmbx;
	
	/* %jp{Ĺס} */
	cmpf.mpfatr = TA_TFIFO;					
	cmpf.blkcnt = 3;						
	cmpf.blksz  = sizeof(T_PRINT_MSG);		
	cmpf.mpf    = NULL;						
	mpfid = acre_mpf(&cmpf);

	/* %jp{᡼ܥå} */
	cmbx.mbxatr  = TA_TFIFO | TA_TFIFO;		
	cmbx.maxmpri = 1;						
	cmbx.mprihd  = NULL;					
	mbxid = acre_mbx(&cmbx);

	/* %jp{ư} */
	act_tsk(TSKID_PRINT);
	act_tsk(TSKID_SAMPLE1);
}


/** %jp{100msԤ} */
void t_wait(void)
{
	dly_tsk(100);	
}


/** %jp{ɽ} */
void print(char *text)
{
	T_PRINT_MSG *msg;
	VP  mem;
	
	/* %jp{} */
	get_mpf(mpfid, &mem);
	msg = (T_PRINT_MSG *)mem;

	/* %jp{ʸ} */
	strcpy(&msg->text[0], text);
	strcat(msg->text, "\n");
	
	/* %jp{ɽ} */
	snd_mbx(mbxid, (T_MSG *)msg);
}


/** %jp{ץ륿} */
void Sample_Task(VP_INT exinf)
{
	char buf[16];
	unsigned int wc,wd;
	unsigned int wb;
	unsigned int we = 0x0000;
	print("Start\r");

	for ( ; ; )
	{
		wc = *REG_PC_DR; /* ݡC  */
		wc &= 0x0400;
		wd = *REG_PD_DR; /* ݡD  */
		wd &= 0x0400;
		buf[0] = 0;
		wb = 0;
		if (wc) {
		  strcat(buf, "SW1:ON ");
		  wb |= 0x0080; /* LED1 ON */
		} else {
		  strcat(buf, "SW1:OFF ");
		}
		if(wd) {
		  wb |= 0x0040; /* LED2 ON */
		  strcat(buf, "SW2:ON\r");
		} else {
		  strcat(buf, "SW2:OFF\r");
		}
		*REG_PB_DR = wb; /* ݡB  */
		print(buf);
		we = ~we;
		*REG_PE_DRL = we; /* ľLED */
		t_wait();
	}
}


/** %jp{ɽ} */
void Sample_Print(VP_INT exinf)
{
	T_PRINT_MSG *msg;
	
	Sci1_Initialize();
	
	for ( ; ; )
	{
		rcv_mbx(mbxid, (T_MSG **)&msg);
/*		sim_puts(msg->text);	*/
		Sci1_PutString(msg->text);
		rel_mpf(mpfid, msg);
	}
}






/* end of file */
